<?php
require_once dirname(__FILE__) . '/osbrowser.php';
/************************************************************\
* WP NOW - Get Configuration Option
\************************************************************/
$wpn_config = (array)get_option('wpn_theme_options_gamenow');
function get_wpn_config($var) {
	global $wpn_config;
	
	if(array_key_exists($var,$wpn_config)) {
		return $wpn_config[$var];
	}
	else {
		return false;
	}
}

/************************************************************\
* WP NOW - Remove Default Widgets
\************************************************************/
function unregister_widgets()
{
    unregister_sidebar_widget('categories');
    unregister_sidebar_widget('search');
    unregister_sidebar_widget('recent-comments');
    unregister_sidebar_widget('recent-posts');
}
add_action('widgets_init','unregister_widgets');

if ( function_exists('register_sidebar') )
{	
    register_sidebars(1, array(
	'name'	=>	'Gamenow Sidebar',
    'before_title' => '<span class="heading2"><span>',
    'after_title' => ' </span></span><div class="box">',
    'before_widget' => '',
    'after_widget' => '<div class="clear"></div></div>',
    ) );
}

/************************************************************\
* WP NOW - Featured Content Title Limit
\************************************************************/

function featured_content_title()
{
    $title = get_the_title();
    $limit = "50";
    $pad="...";
    if(strlen($title) <= $limit)
    {
        echo $title;
    }
    else
    {
        $title = substr($title, 0, $limit) . $pad;
        echo $title;
    }
}

/************************************************************\
* WP NOW - News & Updates Title Limit
\************************************************************/

function news_and_updates_title()
{
    $title = get_the_title();
    $limit = "35";
    $pad="...";
    if(strlen($title) <= $limit)
    {
        echo $title;
    }
    else
    {
        $title = substr($title, 0, $limit) . $pad;
        echo $title;
    }
}

/************************************************************\
* WP NOW - Category Title Limit
\************************************************************/

function category_title()
{
    $title = get_the_title();
    $limit = "45";
    $pad="...";
    if(strlen($title) <= $limit)
    {
        echo $title;
    }
    else
    {
        $title = substr($title, 0, $limit) . $pad;
        echo $title;
    }
}

/************************************************************\
* WP NOW - Content Limit
\************************************************************/

function wpn_content_limit($content, $ilimit = false)
{
    $limit = ($ilimit) ? $ilimit : 270;
    $pad="...";
    $content = strip_tags($content);
	$pattern = '|[[\/\!]*?[^\[\]]*?]|si';
	$replace = '';
	$content = preg_replace($pattern, $replace, $content);

    if(strlen($content) > $limit)
    {
        $content = substr($content,0,$limit);
    }
    echo $content.$pad;
}

/************************************************************\
* WP NOW - Content Show
\************************************************************/

function wpn_content_show($limit)
{
    if(is_category() || is_archive())
    {
        if (!empty($post->post_excerpt))
        {
            the_excerpt();
        }
        else
        {
            wpn_content_limit(get_the_content(), $limit);
        }
    }
    else
    {
        wpn_content_limit(get_the_content(), $limit);
    }
}

/************************************************************\
* WP NOW - Nested Comments
\************************************************************/

$i = 1;
function wpn_gamenow_comment($comment, $args, $depth)
{
	$GLOBALS['comment'] = $comment; 
	global $i;
?>
		<li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
			<div class="cwrap">
				<span class="avatar"><?php echo get_avatar($comment,$size='60',$default=''. get_bloginfo('stylesheet_directory') .'/img/avatar.jpg' ); ?></span>
				<span class="author"><?php comment_author_link(); ?></span><br />
				<span class="date"><?php printf(__('%1$s'), get_comment_date(),  get_comment_time()) ?></span><br />
				<span class="reply">
				<?php
					comment_reply_link(array_merge($args, array(
						'reply_text'	=>	'Reply',
						'depth' => $depth,
						'max_depth' => $args['max_depth']
					)));
				?>
				</span>
				<strong class="cnumber"><span>#</span><?php echo $i; ?></strong>
				<?php if (defined("STARRATING_INSTALLED")) : ?>
				<span class="ratec"><?php wp_gdsr_render_comment(); ?></span>
				<?php endif; ?>
				<div class="clear"></div>
				<div class="ctext">
					<span class="triangle"></span>
					<?php if ($comment->comment_approved == '0') : ?>
						<strong><em><?php _e('Your comment is awaiting moderation.') ?></em></strong><br />
					<?php endif; ?>
					<div>
						<?php comment_text() ?>
					</div>
				</div>
			</div>
			<div class="clear"></div>
			<div id="comment-<?php comment_ID(); ?>"></div>
<?php
	$i++;
}

/************************************************************\
* 2.8 Widgets
\************************************************************/
if(class_exists('WP_Widget')) {
	
	/************************************************************\
	* WP NOW - Latest Comments (2.8) Widget
	\************************************************************/
	class widget_wpn_latestc extends WP_Widget {
		/** constructor */
		function widget_wpn_latestc() {
			parent::WP_Widget(false, $name = 'WP Now: Latest Comments');	
		}

		/** @see WP_Widget::widget */
		function widget($args, $instance) {
			extract( $args );
			global $wpdb;
			?>
				<!-- Latest Comments // -->
				<span class="heading2"><span><?php echo $instance['title']; ?></span></span>
				<div class="box">
					<ul class="latestc">
						<?php
							$sql = "
								SELECT DISTINCT ID, post_title, post_password, comment_ID, 
								comment_post_ID, comment_author_email, 
								comment_author, comment_date_gmt, comment_approved, comment_type,comment_author_url, 
								SUBSTRING(comment_content,1,35) AS com_excerpt 
								FROM $wpdb->comments 
								LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID = $wpdb->posts.ID) 
								WHERE comment_approved = '1' 
								AND comment_type = '' 
								AND post_password = '' 
								ORDER BY comment_date_gmt DESC LIMIT ".$instance['limit'];

							$comments = $wpdb->get_results($sql);

							foreach ($comments as $comment)  {
								$output .= "
									<li>".get_avatar($comment->comment_author_email,'20',$default=''.get_bloginfo('stylesheet_directory') .'/img/avatar.jpg')."<a href=\"" . get_permalink($comment->ID) . "#comment-" . $comment->comment_ID . "\">".strip_tags($comment->comment_author)."</a> on <a href=\"" . get_permalink($comment->ID)."\">".$comment->post_title."</a><span class=\"clear\"></span></li>";
							}
							echo $output;
						?>
					</ul>
				</div>
				<!-- // Latest Comments -->
			<?php
		}

		/** @see WP_Widget::update */
		function update($new_instance, $old_instance) {				
			return $new_instance;
		}

		/** @see WP_Widget::form */
		function form($instance) {				
			$title = esc_attr( ($instance['title']) ? $instance['title'] : "Latest Comments" );
			$limit = esc_attr( ($instance['limit']) ? $instance['limit'] : 5 );
			?>
			<p><label for="<?php echo $this->get_field_id('title'); ?>">
				<?php _e('Title:'); ?>
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
			</label></p>
			<p><label for="<?php echo $this->get_field_id('limit'); ?>">
				<?php _e('Limit:'); ?>
				<input class="widefat" id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="text" value="<?php echo $limit; ?>" />
			</label></p>
			<?php 
		}
	}
	add_action('widgets_init', create_function('', 'return register_widget("widget_wpn_latestc");'));
	
	/************************************************************\
	* WP NOW - Latest Reviews (2.8) Widget
	\************************************************************/
	class widget_wpn_latestr extends WP_Widget {
		/** constructor */
		function widget_wpn_latestr() {
			parent::WP_Widget(false, $name = 'WP Now: Latest Reviews');	
		}

		/** @see WP_Widget::widget */
		function widget($args, $instance) {
			extract( $args );
			global $wpdb,$post;
			$latestr = new WP_Query("tag=review&showposts=".$instance['limit']);
			?>
				<!-- Latest Reviews // -->
				<span class="heading2"><span><?php echo $instance['title']; ?></span></span>
				<div class="box">
					<ul class="latestrp">
					<?php if($latestr->have_posts()) : ?>
						<?php while($latestr->have_posts()) : $latestr->the_post();?>
						<li>
							<?php if(get_post_meta($post->ID, "thumbnail_small", true)) : ?>
								<img src="<?php echo get_post_meta($post->ID, "thumbnail_small", true); ?>" />
							<?php endif; ?>
							<a href="<?php the_permalink(); ?>"><?php echo wpn_content_limit(get_the_title(),20); ?></a>
							<span>Filed under: <?php the_category(', '); ?></span>
							<?php if (defined("STARRATING_INSTALLED")) : ?>
							<div class="score"><?php wp_gdsr_show_article_review(); ?></div>
							<?php endif; ?>
						</li>
						<?php endwhile; ?>
					<?php else: ?>
						<li>No posts found</li>
					<?Php endif; ?>
					</ul>
				</div>
				<!-- // Latest Reviews -->
			<?php
		}

		/** @see WP_Widget::update */
		function update($new_instance, $old_instance) {				
			return $new_instance;
		}

		/** @see WP_Widget::form */
		function form($instance) {				
			$title = esc_attr( ($instance['title']) ? $instance['title'] : "Latest Reviews" );
			$limit = esc_attr( ($instance['limit']) ? $instance['limit'] : 5 );
			?>
			<p><label for="<?php echo $this->get_field_id('title'); ?>">
				<?php _e('Title:'); ?>
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
			</label></p>
			<p><label for="<?php echo $this->get_field_id('limit'); ?>">
				<?php _e('Limit:'); ?>
				<input class="widefat" id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="text" value="<?php echo $limit; ?>" />
			</label></p>
			<?php 
		}
	}
	add_action('widgets_init', create_function('', 'return register_widget("widget_wpn_latestr");'));
	
	/************************************************************\
	* WP NOW - Latest Previews (2.8) Widget
	\************************************************************/
	class widget_wpn_latestp extends WP_Widget {
		/** constructor */
		function widget_wpn_latestp() {
			parent::WP_Widget(false, $name = 'WP Now: Latest Previews');	
		}

		/** @see WP_Widget::widget */
		function widget($args, $instance) {
			extract( $args );
			global $wpdb,$post;
			$latestp = new WP_Query("tag=preview&showposts=".$instance['limit']);
			?>
				<!-- Latest Previews // -->
				<span class="heading2"><span><?php echo $instance['title']; ?></span></span>
				<div class="box">
					<ul class="latestrp">
					<?php if($latestp->have_posts()) : ?>
						<?php while($latestp->have_posts()) : $latestp->the_post();?>
						<li>
							<?php if(get_post_meta($post->ID, "thumbnail_small", true)) : ?>
								<img src="<?php echo get_post_meta($post->ID, "thumbnail_small", true); ?>" />
							<?php endif; ?>
							<a href="<?php the_permalink(); ?>"><?php echo wpn_content_limit(get_the_title(),30); ?></a>
							<span>Filed under: <?php the_category(', '); ?></span>
						</li>
						<?php endwhile; ?>
					<?php else: ?>
						<li>No posts found</li>
					<?Php endif; ?>
					</ul>
				</div>
				<!-- // Latest Previews -->
			<?php
		}

		/** @see WP_Widget::update */
		function update($new_instance, $old_instance) {				
			return $new_instance;
		}

		/** @see WP_Widget::form */
		function form($instance) {				
			$title = esc_attr( ($instance['title']) ? $instance['title'] : "Latest Previews" );
			$limit = esc_attr( ($instance['limit']) ? $instance['limit'] : 5 );
			?>
			<p><label for="<?php echo $this->get_field_id('title'); ?>">
				<?php _e('Title:'); ?>
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
			</label></p>
			<p><label for="<?php echo $this->get_field_id('limit'); ?>">
				<?php _e('Limit:'); ?>
				<input class="widefat" id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="text" value="<?php echo $limit; ?>" />
			</label></p>
			<?php 
		}
	}
	add_action('widgets_init', create_function('', 'return register_widget("widget_wpn_latestp");'));

/************************************************************\
* <= 2.7 Widgets
\************************************************************/
} else {
		
	/************************************************************\
	* WP NOW - Latest Comments (<= 2.7) Widget
	\************************************************************/
	function widget_wpn_latestc() {
	?>
		<!-- Latest Comments // -->
		<span class="heading2"><span>Latest Comments</span></span>
		<div class="box">
			<ul class="latestc">
				<?php
					$sql = "
						SELECT DISTINCT ID, post_title, post_password, comment_ID, 
						comment_post_ID, comment_author_email, 
						comment_author, comment_date_gmt, comment_approved, comment_type,comment_author_url, 
						SUBSTRING(comment_content,1,35) AS com_excerpt 
						FROM $wpdb->comments 
						LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID = $wpdb->posts.ID) 
						WHERE comment_approved = '1' 
						AND comment_type = '' 
						AND post_password = '' 
						ORDER BY comment_date_gmt DESC LIMIT 5";

					$comments = $wpdb->get_results($sql);

					foreach ($comments as $comment)  {
						$output .= "
							<li>".get_avatar($comment->comment_author_email,'20',$default=''.get_bloginfo('stylesheet_directory') .'/img/avatar.jpg')."<a href=\"" . get_permalink($comment->ID) . "#comment-" . $comment->comment_ID . "\">".strip_tags($comment->comment_author)."</a> on <a href=\"" . get_permalink($comment->ID)."\">".$comment->post_title."</a><span class=\"clear\"></span></li>";
					}
					echo $output;
				?>
			</ul>
		</div>
		<!-- // Latest Comments -->
	<?php
	}
	if (function_exists('register_sidebar_widget'))
		register_sidebar_widget(__('WP Now: Latest Comments'), 'widget_wpn_latestc');
		
	/************************************************************\
	* WP NOW - Latest Reviews (<= 2.7) Widget
	\************************************************************/
	function widget_wpn_latestr() {
	global $post;
	$latestr = new WP_Query("tag=review&showposts=5");
	?>
		<!-- Latest Reviews // -->
		<span class="heading2"><span>Latest Reviews</span></span>
		<div class="box">
			<ul class="latestrp">
			<?php if($latestr->have_posts()) : ?>
				<?php while($latestr->have_posts()) : $latestr->the_post();?>
				<li>
					<?php if(get_post_meta($post->ID, "thumbnail_small", true)) : ?>
						<img src="<?php echo get_post_meta($post->ID, "thumbnail_small", true); ?>" />
					<?php endif; ?>
					<a href="<?php the_permalink(); ?>"><?php echo wpn_content_limit(get_the_title(),20); ?></a>
					<span>Filed under: <?php the_category(', '); ?></span>
					<?php if (defined("STARRATING_INSTALLED")) : ?>
					<div class="score"><?php wp_gdsr_show_article_review(); ?></div>
					<?php endif; ?>
				</li>
				<?php endwhile; ?>
			<?php else: ?>
				<li>No posts found</li>
			<?Php endif; ?>
			</ul>
		</div>
		<!-- // Latest Reviews -->
	<?php
	}
	if (function_exists('register_sidebar_widget'))
		register_sidebar_widget(__('WP Now: Latest Reviews'), 'widget_wpn_latestr');
		
	/************************************************************\
	* WP NOW - Latest Previews (<= 2.7) Widget
	\************************************************************/
	function widget_wpn_latestp() {
	global $post;
	$latestp = new WP_Query("tag=preview&showposts=5");
	?>
		<!-- Latest Previews // -->
		<span class="heading2"><span>Latest Previews</span></span>
		<div class="box">
			<ul class="latestrp">
			<?php if($latestp->have_posts()) : ?>
				<?php while($latestp->have_posts()) : $latestp->the_post();?>
				<li>
					<?php if(get_post_meta($post->ID, "thumbnail_small", true)) : ?>
						<img src="<?php echo get_post_meta($post->ID, "thumbnail_small", true); ?>" />
					<?php endif; ?>
					<a href="<?php the_permalink(); ?>"><?php echo wpn_content_limit(get_the_title(),30); ?></a>
					<span>Filed under: <?php the_category(', '); ?></span>
				</li>
				<?php endwhile; ?>
			<?php else: ?>
				<li>No posts found</li>
			<?Php endif; ?>
			</ul>
		</div>
		<!-- // Latest Previews -->
	<?php
	}
	if (function_exists('register_sidebar_widget'))
		register_sidebar_widget(__('WP Now: Latest Previews'), 'widget_wpn_latestp');

}

// Theme Options
add_action('admin_menu', 'wpn_add_options_page');
function wpn_add_options_page() {
	add_theme_page(__('Theme Options'), __('Theme Options'), 'edit_themes', basename('./theme_options.php'), 'wpn_options_page');
}

require('theme_options.php');

function wpn_custom_menus() {
    register_nav_menus(array('topnav' => __('Top Navigation'), 'topsubnav' => __('Top Sub Navigation'), 'footernav' => __('Footer Navigation'), 'footersubnav' => __('Footer Sub Navigation')));
}
add_action('after_setup_theme', 'wpn_custom_menus');

function wpn_topnav_cb() {
    ?>
    <ul class="menu">
        <li><a href="<?php echo get_option('home'); ?>">Home</a></li>
        <?php
        if(get_wpn_config('menu_display') == 2) {
                $menu_filter = '&include='.get_wpn_config('menu_filter');
        }
        if(get_wpn_config('menu_display') == 3) {
                $menu_filter = '&exclude_tree='.get_wpn_config('menu_filter');
        }
        wp_list_pages('sort_column=menu_order&title_li=&depth=0'.$menu_filter);
        ?>
    </ul>
    <?php
}
function wpn_topsubnav_cb() {
    ?>
    <ul class="submenu">
            <?php
            if(get_wpn_config('submenu_display') == 2) {
                    $submenu_filter = '&include='.get_wpn_config('submenu_filter');
            }
            if(get_wpn_config('submenu_display') == 3) {
                    $submenu_filter = '&exclude='.get_wpn_config('submenu_filter');
            }
            wp_list_categories('sort_column=menu_order&title_li=&show_count=0'.$submenu_filter);
            ?>
    </ul>
    <?php
}
function wpn_footernav_cb() {
    ?>
    <ul class="pages">
        <li><a href="<?php echo get_option('home'); ?>">Home</a></li>
        <?php wp_list_pages('sort_column=menu_order&title_li=&depth=1&include='.get_wpn_config('toplinks_include').'&exclude_tree='.get_wpn_config('toplinks_exclude')); ?>
    </ul>
    <?php
}
function wpn_footersubnav_cb() {
    ?>
    <ul class="cats">
            <?php wp_list_categories('sort_column=menu_order&title_li=&depth=1&show_count=0&include='.get_wpn_config('menu_include').'&exclude='.get_wpn_config('menu_exclude')); ?>
    </ul>
    <?php
}
