<?php

/**
 * OsBrowser
 * 
 * A class to get visitor's os and browser
 *
 * @author Krishna Kant Sharma (http://www.krishnakantsharma.com)
 */

  class OsBrowser {
       
       static $os=false;
       static $browser=false;
       static $browserVersion=false;
       public static function init() {
            $browser = $_SERVER[ 'HTTP_USER_AGENT' ];
            // Mac, PC ...or Linux
            if ( preg_match( "/Mac/", $browser ) ){
                self::$os = 'mac';
            
            } elseif ( preg_match( "/Windows/", $browser ) ){
                self::$os = 'windows';
            
            } elseif ( preg_match( "/Linux/", $browser ) ) {
                self::$os = 'linux';

            } else {
                self::$os = 'unknown-os';
            }

            // Checks browsers in this order: Chrome, Safari, Opera, MSIE, FF
            if ( preg_match( "/Chrome/", $browser ) ) {
                self::$browser = 'chrome';

                preg_match( "/Chrome\/(\d.\d)/si", $browser, $matches);
                $ch_version = 'ch' . str_replace( '.', '-', $matches[1] );      
                self::$browserVersion = $ch_version;

            } elseif ( preg_match( "/Safari/", $browser ) ) {
                self::$browser = 'safari';
                
                preg_match( "/Version\/(\d.\d)/si", $browser, $matches);
                $sf_version = 'sf' . str_replace( '.', '-', $matches[1] );      
                self::$browserVersion = $sf_version;
                
            } elseif ( preg_match( "/Opera/", $browser ) ) {
                self::$browser = 'opera';
                
                preg_match( "/Opera\/(\d.\d)/si", $browser, $matches);
                $op_version = 'op' . str_replace( '.', '-', $matches[1] );      
                self::$browserVersion = $op_version;
                
            } elseif ( preg_match( "/MSIE/", $browser ) ) {
                self::$browser = 'msie';
                
                if( preg_match( "/MSIE 6.0/", $browser ) ) {
                        self::$browserVersion = 'ie6';
                } elseif ( preg_match( "/MSIE 7.0/", $browser ) ){
                        self::$browserVersion = 'ie7';
                } elseif ( preg_match( "/MSIE 8.0/", $browser ) ){
                        self::$browserVersion = 'ie8';
                }
                
            } elseif ( preg_match( "/Firefox/", $browser ) && preg_match( "/Gecko/", $browser ) ) {
                self::$browser = 'firefox';
                
                preg_match( "/Firefox\/(\d)/si", $browser, $matches);
                $ff_version = 'ff' . str_replace( '.', '-', $matches[1] );      
                self::$browserVersion = $ff_version;
                
            } else {
                self::$browser = 'unknown-browser';
            }
       } 
       public static function getOs() {
            return self::$os;
       }  
       public static function getBrowser() {
            return self::$browser;   
       }
       public static function getBrowserVersion() {
            return self::$browserVersion;   
       }
       public static function getCssClass() {
           return self::$os . ' ' . self::$browser . ' ' . self::$browserVersion;
       }
       public static function isWindows() {
            return self::$os == "windows";   
       }
       public static function isMac() {
            return self::$os == "mac";   
       }
       public static function isLinux() {
            return self::$os == "linux";   
       }
       public static function isChrome() {
            return self::$browser == "chrome";   
       }
       public static function isSafari() {
            return self::$browser == "safari";   
       }
       public static function isOpera() {
            return self::$browser == "opera";   
       }
       public static function isIE() {
            return self::$browser == "msie";   
       }
       public static function isIE6() {
            return self::$browserVersion == "ie6";   
       }
       public static function isIE7() {
            return self::$browserVersion == "ie7";   
       }
       public static function isIE8() {
            return self::$browserVersion == "ie8";   
       }
       public static function isFirefox() {
            return self::$browserVersion == "firefox";   
       }
       
       
       
  }

OsBrowser::init();