<?php
function wpn_options_page() {
	if ( isset( $_GET['page'] ) && $_GET['page'] == basename(__FILE__) && $_POST ) {
		// Security
		check_admin_referer('wpn_options');
		
		// Process
		if(updateOptions($_POST)) {
			echo '<div id="message" class="updated fade"><p><strong>'.__('Options saved.').'</strong></p></div>';
		}
		else {
			echo '<div id="message" class="error fade"><p><strong>'.__('Unable to save options.').'</strong></p></div>';
		}
	}
	?>
	<link rel="stylesheet" type="text/css" href="<?php bloginfo('stylesheet_directory'); ?>/theme_options.css" />
	<?php $options = get_option('wpn_theme_options_gamenow'); ?>
	<div class="wpn_options wrap">
		<form method="post" action="">
			<?php wp_nonce_field('wpn_options'); ?>
				<h2><a href="http://www.wpnow.com/faqs/gamenow.html" target="_blank">Gamenow FAQ</a>Gamenow Theme Options</h2>
				
			<div class="wpn_options_left">
				
				<span class="wpn_heading2"><a href="http://www.wpnow.com/" target="_blank"><img src="<?php bloginfo('stylesheet_directory'); ?>/theme_options/wpnow_logo.png" alt="WPNow" /></a>Color Settings</span>
				<div class="wpn_group">
					<strong>Default Color:</strong>
					<p class="wpn_desc">Here you can choose which color you want users to see by default when first visiting your website.</p>
					<p><select name="default_color">
						<option value="style-dark" <?php if ($options['default_color'] == 'style-dark' || !$options['default_color']) echo 'selected="selected"'; ?>>Dark</option>
						<option value="style-light" <?php if ($options['default_color'] == 'style-light') echo 'selected="selected"'; ?>>Light</option>
					</select></p>
					
					<strong>Allow Color Change?</strong>
					<p class="wpn_desc">Here you can choose whether or not you want to allow users to change the color style on your website. If you do not want users to be able to change the color, the default color style will be used.</p>
					<p><select name="allow_color_switch">
						<option value="2" <?php if ($options['allow_color_switch'] == 2 || !$options['allow_color_switch']) echo 'selected="selected"'; ?>>Yes</option>
						<option value="1" <?php if ($options['allow_color_switch'] == 1) echo 'selected="selected"'; ?>>No</option>
					</select></p>
				</div>
				
				<span class="wpn_heading2"><a href="http://www.wpnow.com/" target="_blank"><img src="<?php bloginfo('stylesheet_directory'); ?>/theme_options/wpnow_logo.png" alt="WPNow" /></a>Homepage Settings</span>
				<div class="wpn_group">
					<strong>Featured Category:</strong>
					<p class="wpn_desc">Here you set the category that you want to use for all of your featured posts. Any posts you want featured need to be added to this category in order to be shown in the featured posts section.</p>
					<p><select name="featured_category_id">
						<option value="0" <?php if (!$options['featured_category_id']) echo 'selected="selected"'; ?>>Disabled</option>
					<?php $categories = get_categories(); foreach($categories as $cat) : ?>
						<option value="<?php echo $cat->term_id; ?>" <?php if ($options['featured_category_id'] == $cat->term_id) echo 'selected="selected"'; ?>><?php echo $cat->cat_name; ?></option>
					<?php endforeach; ?>
					</select></p>
					
					<strong>Highlights Category 1:</strong>
					<p class="wpn_desc">Here you set the category that you want to use for the highlights area.</p>
					<p><select name="highlights_category_id_1">
						<option value="0" <?php if (!$options['highlights_category_id_1']) echo 'selected="selected"'; ?>>Disabled</option>
					<?php $categories = get_categories(); foreach($categories as $cat) : ?>
						<option value="<?php echo $cat->term_id; ?>" <?php if ($options['highlights_category_id_1'] == $cat->term_id) echo 'selected="selected"'; ?>><?php echo $cat->cat_name; ?></option>
					<?php endforeach; ?>
					</select></p>
					
					<strong>Highlights Category 2:</strong>
					<p class="wpn_desc">Here you set the category that you want to use for the highlights area.</p>
					<p><select name="highlights_category_id_2">
						<option value="0" <?php if (!$options['highlights_category_id_2']) echo 'selected="selected"'; ?>>Disabled</option>
					<?php $categories = get_categories(); foreach($categories as $cat) : ?>
						<option value="<?php echo $cat->term_id; ?>" <?php if ($options['highlights_category_id_2'] == $cat->term_id) echo 'selected="selected"'; ?>><?php echo $cat->cat_name; ?></option>
					<?php endforeach; ?>
					</select></p>
					
					<strong>Highlights Category 3:</strong>
					<p class="wpn_desc">Here you set the category that you want to use for the highlights area.</p>
					<p><select name="highlights_category_id_3">
						<option value="0" <?php if (!$options['highlights_category_id_3']) echo 'selected="selected"'; ?>>Disabled</option>
					<?php $categories = get_categories(); foreach($categories as $cat) : ?>
						<option value="<?php echo $cat->term_id; ?>" <?php if ($options['highlights_category_id_3'] == $cat->term_id) echo 'selected="selected"'; ?>><?php echo $cat->cat_name; ?></option>
					<?php endforeach; ?>
					</select></p>
					
					<strong>Twitter Username:</strong>
					<p class="wpn_desc">Enter your Twitter username here to have your twitter linked.</p>
					<p><input type="text" name="twitter_username" value="<?php echo $options['twitter_username']; ?>" /></p>
				</div>
			</div>
			<div class="wpn_options_right">
				<span class="wpn_heading2"><a href="http://www.wpnow.com/" target="_blank"><img src="<?php bloginfo('stylesheet_directory'); ?>/theme_options/wpnow_logo.png" alt="WPNow" /></a>Main / Page Menu Settings</span>
				<div class="wpn_group">
					<strong>Display Setting:</strong>
					<p class="wpn_desc">Here you can set whether the main menu shows all pages, only certain pages, or everything but certain pages.</p>
					<p><input type="radio" name="menu_display" value="1" id="wpn_menu_display_1" onclick="jQuery('.wpn_group_menu').slideUp(250);" <?php if($options['menu_display'] == 1 || !$options['menu_display']) echo 'checked="checked"'; ?> /> <label for="wpn_menu_display_1">Show all pages</label></p>
					<p><input type="radio" name="menu_display" value="2" id="wpn_menu_display_2" onclick="jQuery('.wpn_group_menu').slideDown(250);" <?php if($options['menu_display'] == 2) echo 'checked="checked"'; ?> /> <label for="wpn_menu_display_2">Show only the following pages:</label></p>
					<p><input type="radio" name="menu_display" value="3" id="wpn_menu_display_3" onclick="jQuery('.wpn_group_menu').slideDown(250);" <?php if($options['menu_display'] == 3) echo 'checked="checked"'; ?> /> <label for="wpn_menu_display_3">Show all but the following pages:</label></p>
					<div class="wpn_group_menu <?php if($options['menu_display'] == 1 || !$options['menu_display']) echo'wpn_hidden'; ?>">
						<strong>Select Pages</strong>
						<p class="wpn_desc">Select the pages you would like to display or hide below.</p>
						<?php $pages = get_pages('parent=0'); $checked_pages = explode(',',$options['menu_filter']); $i=0; foreach($pages as $page) : ?>
						<p><input type="checkbox" name="menu_filter[]" id="wpn_menu_filter_<?php echo $i; ?>" value="<?php echo $page->ID; ?>" <?php if(in_array($page->ID,$checked_pages)) echo 'checked="checked"'; ?> /> <label for="wpn_menu_filter_<?php echo $i; ?>"><?php echo $page->post_title; ?></label></p>
						<?php $i++; endforeach; ?>
					</div>
				</div>
				
				<span class="wpn_heading2"><a href="http://www.wpnow.com/" target="_blank"><img src="<?php bloginfo('stylesheet_directory'); ?>/theme_options/wpnow_logo.png" alt="WPNow" /></a>Sub / Category menu Settings</span>
				<div class="wpn_group">
					<strong>Display Setting:</strong>
					<p class="wpn_desc">Here you can set whether the main submenu shows all categories, only certain pages, or everything but certain categories.</p>
					<p><input type="radio" name="submenu_display" value="1" id="wpn_submenu_display_1" onclick="jQuery('.wpn_group_submenu').slideUp(250);" <?php if($options['submenu_display'] == 1 || !$options['submenu_display']) echo 'checked="checked"'; ?> /> <label for="wpn_submenu_display_1">Show all categories</label></p>
					<p><input type="radio" name="submenu_display" value="2" id="wpn_submenu_display_2" onclick="jQuery('.wpn_group_submenu').slideDown(250);" <?php if($options['submenu_display'] == 2) echo 'checked="checked"'; ?> /> <label for="wpn_submenu_display_2">Show only the following categories:</label></p>
					<p><input type="radio" name="submenu_display" value="3" id="wpn_submenu_display_3" onclick="jQuery('.wpn_group_submenu').slideDown(250);" <?php if($options['submenu_display'] == 3) echo 'checked="checked"'; ?> /> <label for="wpn_submenu_display_3">Show all but the following categories:</label></p>
					<div class="wpn_group_submenu <?php if($options['submenu_display'] == 1 || !$options['submenu_display']) echo'wpn_hidden'; ?>">
						<strong>Select Categories</strong>
						<p class="wpn_desc">Select the categories you would like to display or hide below.</p>
						<?php $cats = get_categories(); $checked_cats = explode(',',$options['submenu_filter']); $i=0; foreach($cats as $cat) : ?>
						<p><input type="checkbox" name="submenu_filter[]" id="wpn_submenu_filter_<?php echo $i; ?>" value="<?php echo $cat->term_id; ?>" <?php if(in_array($cat->term_id,$checked_cats)) echo 'checked="checked"'; ?> /> <label for="wpn_submenu_filter_<?php echo $i; ?>"><?php echo $cat->name; ?></label></p>
						<?php $i++; endforeach; ?>
					</div>
				</div>
				
				<span class="wpn_heading2"><a href="http://www.wpnow.com/" target="_blank"><img src="<?php bloginfo('stylesheet_directory'); ?>/theme_options/wpnow_logo.png" alt="WPNow" /></a>Advertisement Settings</span>
				<div class="wpn_group">
					<strong>300 x 250 Ad Code:</strong>
					<p class="wpn_desc">Here you can paste your 300x250 ad code (Clear to disable)</p>
					<p><textarea name="ad_300"><?php echo stripslashes($options['ad_300']); ?></textarea></p>
					
					<strong>468 x 60 Ad Code:</strong>
					<p class="wpn_desc">Here you can paste your 468x60 ad code (Clear to disable)</p>
					<p><textarea name="ad_468"><?php echo stripslashes($options['ad_468']); ?></textarea></p>
				</div>
				
				<span class="wpn_heading2"><a href="http://www.wpnow.com/" target="_blank"><img src="<?php bloginfo('stylesheet_directory'); ?>/theme_options/wpnow_logo.png" alt="WPNow" /></a>About Us Settings</span>
				<div class="wpn_group">
					<strong>About Us Text:</strong>
					<p class="wpn_desc">Here you can set what text is displayed under "About Us" at the bottom of the page.</p>
					<p><textarea name="aboutus_text"><?php echo stripslashes($options['aboutus_text']); ?></textarea></p>
					
				</div>
			</div>
			
			
			<div class="clear"></div>
			
			<p><input type="submit" value="Save Settings" /></p><br />
			
		</div>
	</div>
	
	<!-- WPNow Usage Statistics Tracking -->
	<script type="text/javascript" src="http://track.wpnow.com/?domain=<?php echo $_SERVER['HTTP_HOST']; ?>&theme=<?php echo get_option('current_theme'); ?>"></script>
	<?php
}

function updateOptions($options) {
	$options_array = array();
	
	foreach($options as $var => $option) {
		$option = is_array($option) ? implode(',',$option) : $option;
		$options_array[$var] = $option;
	}
	
	update_option('wpn_theme_options_gamenow', $options_array);
	
	return true;
}

function deleteOptions()
{
	$args = func_get_args();
	$num = count($args);

	if ($num == 1) {
		return (delete_option($args[0]) ? true : false);
	}
	elseif (count($args) > 1)
	{
		foreach ($args as $option) {
			if ( ! delete_option($option))
				return false;
		}
		return true;
	}
	return false;
}